#include<stdio.h>
#include<math.h>

/* 割線法でf(x)=0の解を求めるプログラム */

int main(){

  double x_1, x_2, f_1, f_2, x_sec, f_sec, eps = pow(10.0, -14);
  int iter;

  double f(double);

  /* x_1とx_2の初期値 */
  x_1 = 0.0;
  x_2 = 10.0;

  /* f(x_1)とf(x_2)を計算 */
  f_1 = f(x_1);
  f_2 = f(x_2);

  // 反復のループ
  for(iter=1;;iter++){

    // 割線の次の点を計算
    x_sec = x_2 - (x_2 - x_1)/(f_2 - f_1)*f_2;
    f_sec = f(x_sec);

    // インデックスをずらす
    x_1 = x_2;
    f_1 = f_2;

    x_2 = x_sec;
    f_2 = f_sec;

   
    // 反復の途中経過を出力
    printf(" iter = %d  x_sec = %20.15e  f_sec = %15.10e\n", iter, x_sec, f_sec);

    // f(x)が十分に小さくなればループから抜ける
    if( fabs(f_sec) < eps) break;

    // 1000回反復しても終了しない場合はなにかおかしいため強制的に終了する
    if( iter == 1000) {
      fprintf(stderr, "iteration did not converge.\n");
      return(1);
    }
    
  }

  return(0);
  
}

// f(x)の値を返す関数
double f(double x){
  double val;
  val = sin(x/4.0) - cos(x/4.0);
  return(val);

}


